package cpcns.danganzhengli.Export.cotroller;

package .tmp;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganzhengli.Export.util.HeExcel;
import cpcns.danganzhengli.wenshu.danganhe.service.IDDangAnHeService;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.jhsks.xinxifenlei.xitongmokuai.xitongpeizhidaima.model.XiTongDaiMa;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.utils.StringUtil;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/Export"})
public class ExportController extends commonController {
  @Autowired
  private ICommonService commonService;
  
  @Autowired
  private IDDangAnHeService dDangAnHeService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request) throws Exception {
    return "danganzhengli/Export/ExportList";
  }
  
  @RequestMapping({"/getAll.do"})
  public void getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      if (!"querystr".equals(thisName))
        jsonObject.put(thisName, thisValue); 
    } 
    User user = getCurrentUser();
    StringBuffer sqlWhere = new StringBuffer();
    Map<String, String> qx = user.getQuanXianMap();
    Iterator<String> iterator = jsonObject.keys();
    Boolean isqx = Boolean.valueOf(true);
    StringBuffer sqlSearch = new StringBuffer();
    sqlSearch.append(" ( 1=1 ");
    Map<String, String> tjmap = new HashMap<>();
    String quanZongHao = request.getParameter("quanZongHao");
    tjmap.put("quanZongHao", quanZongHao);
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !key.equals("quanZongHao")) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key)) {
          if (key.contains("like")) {
            key = key.substring(0, key.indexOf("like"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
            continue;
          } 
          if (key.contains("notin")) {
            key = key.substring(0, key.indexOf("notin"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " not in ( " + value + ")");
            continue;
          } 
          if (key.contains("_in")) {
            key = key.substring(0, key.indexOf("_in"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " in ( " + value + ")");
            continue;
          } 
          if (key.equals("zhuangTai") && value.equals("2")) {
            sqlWhere.append(" and zhuangTai in(").append("0,2)");
            continue;
          } 
          sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
        } 
      } 
    } 
    sqlSearch.append(" ) and zhuangTai not in (3,4,6) ");
    String querySt = request.getParameter("querystr");
    if (StringUtils.isNotBlank(querySt))
      sqlWhere.append(" ").append(CommStatic.zhuHeQueryJieXi_(querySt)); 
    if (sqlWhere.length() > 0)
      sqlSearch.append(sqlWhere.toString()); 
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    StringBuffer sql = new StringBuffer("select fenLeiHao,hangBiaoShi,xuHao,quanZongHao,fenShu,heRongLiang,zhuangTai,zeRenRenMingCheng,guiDangBuMenMingCheng,baoGuanQiXian,guiDangNianDu,menLei,fenLeiMingCheng,miJi,ruKuFangZhuangTai,guiDangDanWeiMingCheng,guanBianHeHao from D_DangAnHe where ");
    PagerVO pagevo = this.dDangAnHeService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"));
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao")
      .replaceAll("FENSHU", "fenShu").replaceAll("HERONGLIANG", "heRongLiang").replaceAll("QUANZONGHAO", "quanZongHao")
      .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("ZERENRENMINGCHENG", "zeRenRenMingCheng").replaceAll("GUIDANGDANWEIMINGCHENG", "guiDangDanWeiMingCheng")
      .replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian")
      .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MENLEI", "menLei").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng")
      .replaceAll("MIJI", "miJi").replaceAll("RUKUFANGzhuangTai", "ruKuFangZhuangTai").replaceAll("GUANBIANHEHAO", "guanBianHeHao").replaceAll("FENLEIHAO", "fenLeiHao");
    write(response, jsonString);
  }
  
  @RequestMapping({"/heExcel.do"})
  @ResponseBody
  public String heExcel(HttpServletRequest request, HttpServletResponse response) {
    String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
    String nd = getRequest().getParameter("nd");
    StringBuilder sql = new StringBuilder("select baoGuanQiXian,xuHao,fenShu,quanZongHao from D_dangAnHe  where zhuangTai not in(3,4) ");
    if (StringUtils.isNotBlank(guiDangNianDu))
      if (StringUtils.isNotBlank(nd)) {
        sql.append(" and guiDangNianDu ").append(nd).append("'").append(guiDangNianDu).append("'");
      } else {
        sql.append(" and guiDangNianDu").append(" = '").append(guiDangNianDu).append("'");
      }  
    List list = this.commonService.getListSQL(sql.toString());
    String fileName = String.valueOf((new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss")).format(new Date())) + "-" + getRandomName(Integer.valueOf(4)) + ".xlsx";
    String ZERO = "0";
    String[][] titleFieldFormate = { { "档案编号", "XUHAO" }, { "全宗号", "QUANZONGHAO" }, { "归档份数", "FENSHU" }, { "保管期限", "BAOGUANQIXIAN" }, { "页数", "ZERO" }, { "当前库存", "ZERO" } };
    List<XiTongDaiMa> isbgqx = this.commonService.xiTongDaiMaList("11720");
    List<XiTongDaiMa> xtdms = this.commonService.xiTongDaiMaList("7087");
    String path = HeExcel.exportExcelAndDownload(response, null, fileName, titleFieldFormate, list, isbgqx, xtdms);
    try {
      byte[] b = (byte[])null;
      InputStream inputStream = null;
      OutputStream outputStream = null;
      if (path != null) {
        path = StringUtil.dealBasePath(path);
        b = findContentByte(path, true);
      } 
      if (b != null) {
        inputStream = new ByteArrayInputStream(b);
        response.setContentType("application/download");
        response.setCharacterEncoding("UTF-8");
        String agent = getRequest().getHeader("USER-AGENT");
        String encodeStr = "";
        if (agent != null && agent.indexOf("MSIE") == -1) {
          encodeStr = new String(fileName.getBytes("UTF-8"), "ISO8859_1");
        } else {
          encodeStr = new String(fileName.getBytes("GBK"), "ISO8859_1");
        } 
        response.setHeader("Content-Disposition", "attachment;fileName=" + encodeStr);
        ServletOutputStream servletOutputStream = response.getOutputStream();
        int i = 0;
        byte[] buffer = new byte[1024];
        if (inputStream != null) {
          while ((i = inputStream.read(buffer)) != -1)
            servletOutputStream.write(buffer, 0, i); 
          inputStream.close();
          servletOutputStream.flush();
          servletOutputStream.close();
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println("xlsx文件生成成功，读取流下载出现问题！");
    } 
    return "";
  }
  
  private String getRandomName(Integer length) {
    String str = "";
    Random ran = new Random();
    for (int i = 0; i < length.intValue(); i++) {
      boolean b = ran.nextBoolean();
      if (b) {
        str = String.valueOf(str) + (char)(65 + ran.nextInt(26));
      } else {
        str = String.valueOf(str) + String.valueOf(ran.nextInt(10));
      } 
    } 
    return str;
  }
  
  private byte[] findContentByte(String path, boolean type) {
    String cunChuPath = path;
    if (!type)
      cunChuPath = FuJianPathUtils.obtainCiPanPath(path); 
    File f = new File(cunChuPath);
    if (f.exists())
      try {
        InputStream in = new FileInputStream(f);
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        byte[] temp = new byte[1024];
        int size = 0;
        while ((size = in.read(temp)) != -1)
          out.write(temp, 0, size); 
        byte[] b = out.toByteArray();
        out.close();
        in.close();
        return b;
      } catch (IOException e) {
        e.printStackTrace();
        return null;
      }  
    return null;
  }
}
